/*
 * This file is part of TONG.              http://www.nongnu.org/tong
 * Copyright 2004 Owen Swerkstrom
 *
 * TONG! is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * TONG! is distributed in the hope that it will be useful and fun,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY of FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with TONG!; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __TEXT_H__
#define __TEXT_H__

class Text;
class Menu;

#include <stdlib.h>
#include <string.h>

#include "SDL.h"
#include "SDL_image.h"
#include "option.h"

#define NORMAL      0
#define HIGHLIGHTED 96
#define DISABLED    192


class Text {
 private:
  int x, y;
  char* text;
  SDL_Rect destrect;
  SDL_Surface* textbits;
  void LoadGraphics();
 public:
  Text();
  ~Text();
  void SetText(const char*);
  void Init(int, int, const char*);
  void Draw(SDL_Surface*);
};

class Menu {
 private:
  char* content;
  int* states;
  int x, y;
  int boxesw, boxesh;
  unsigned int choices, current;
  bool active;
  SDL_Rect destrect;
  SDL_Surface* textbits;
  SDL_Surface* menubits;
  void CalcArea();
  void LoadGraphics();
 public:
  Menu();
  ~Menu();
  bool IsActive();
  void SetActive(bool);
  void AddChoice(const char*, int);
  bool ModChoice(const char*, unsigned int);
  bool MoveCursor(int);
  int GetState(int);
  bool SetState(int, int);
  int GetChoice();
  void SetChoice(int);
  int NumChoices();
  void SetPos(int, int);
  void Draw(SDL_Surface*);
};


#endif
